using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_Aplicacion.Modelos_Generales;
using Exferia_EntityFramework;
using Exferia_General;
using Exferia_Ventas._0_Modelos;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Reflection;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Transactions;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Ventas._1_Datos
{
    public class VTA_AlbaranesFacturasLineas_Trazabilidad_Datos : ABS_Datos
    {
        #region Listado
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener
        #region Obtener Simple

        private dynamic g_dnm_Modelo_Obtener = null;

        private static int g_int_TotalHilos_Obtener = 1;
        private bool[] g_bol_Hilos_Terminados_Obtener = new bool[g_int_TotalHilos_Obtener];

        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                        " SELECT " +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Modelo.id) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Modelo.idArticulo_Trazabilidad) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idArticulo_Trazabilidad) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Modelo.idAlbaranFacturaLinea) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Modelo.cantidad) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.cantidad) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Modelo.segundaUnidad_cantidad) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.segundaUnidad_cantidad) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Modelo.fechaBorrado) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) + 
                        " FROM " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                        " WHERE " +
                                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) + "  is null AND " +
                                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) + " =@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

                #region Rellenar Tablas Relacionadas
                if (g_dnm_Modelo_Obtener != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Obtener; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Obtener[int_Contador] = false;
                    }

                    //MAE_Articulos_Trazabilidad ##########################################################################################
                    ThreadStart obj_ThreadStart_ARTICULOSTRAZABILIDAD = new ThreadStart(Obtener_ArticulosTrazabilidad_Modelo_Obtener);
                    Thread obj_Thread_ARTICULOSTRAZABILIDAD = new Thread(obj_ThreadStart_ARTICULOSTRAZABILIDAD);
                    obj_Thread_ARTICULOSTRAZABILIDAD.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Obtener)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        #region Tablas Relacioandas
        private void Obtener_ArticulosTrazabilidad_Modelo_Obtener()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEARTICULOSTRAZABILIDAD_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);
                //Obtener valores
                object[] arr_Parametros = { g_dnm_Modelo_Obtener.idArticulo_Trazabilidad };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_dnm_Modelo_Obtener.MAE_Articulos_Trazabilidad = (MAE_Articulos_Trazabilidad)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Obtener[0] = true;
            }
        }
        #endregion
        #endregion

        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public List<long> Obtener_IdsAlbaranesFacturasLineas_PorIdArticuloTrazabilidad(long _lng_idArticulo_Trazabilidad)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<long> lst_idsEntradaMercanciaLinea = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();

                string str_SQL =
                      " SELECT " +
                           nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) +
                       " FROM " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                       " WHERE  " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) + " IS null AND " +
                                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idArticulo_Trazabilidad) + "=@idArticulo_Trazabilidad ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idArticulo_Trazabilidad",  _lng_idArticulo_Trazabilidad)
                };

                //Rellenar el Modelo
                lst_idsEntradaMercanciaLinea = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Obtener_IdsAlbaranesFacturasLineas_PorIdArticuloTrazabilidad), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return lst_idsEntradaMercanciaLinea;
        }

        #endregion

        #region Para Listado

        #region Simple
        private INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = null;

        public INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo Obtener_Registro_Para_Listado_Por_Id(long _lng_id)
        {
            g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = null;

            try
            {
                string str_SQL = Obtener_Consulta_Para_Listado() +
                                " WHERE " +
                                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) + "  is null AND " +
                                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) + " =@id ";
                //where
                List <SqlParameter> lst_Parametros = new List<SqlParameter>();
                lst_Parametros.Add(new SqlParameter("@id", _lng_id));

                //Parametros
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Ejecutar
                Ejecutar_Consulta_Modelo_ParaListado(str_SQL, arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Obtener_Registro_Para_Listado_Por_Id), true);
            }

            return g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo;
        }
        
        #region Ejecutar Consulta Modelo Para Listado
        private static int g_int_TotalHilos_Modelo_PARALISTADO = 3;
        private bool[] g_bol_Hilos_Terminados_Modelo_PARALISTADO = new bool[g_int_TotalHilos_Modelo_PARALISTADO];

        private void Ejecutar_Consulta_Modelo_ParaListado(  string _str_SQL,
                                                            object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo>(_str_SQL, _arr_Parametros).FirstOrDefault();

                #region Rellenar tablas Relacionadas
                if (g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo != null)
                {
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_PARALISTADO; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Modelo_PARALISTADO[int_Contador] = false;
                    }

                    //MAE_Embalajes ##########################################################################################
                    ThreadStart obj_ThreadStart_EMBALAJES = new ThreadStart(Obtener_Embalajes_Modelo_ParaListado);
                    Thread obj_Thread_EMBALAJES = new Thread(obj_ThreadStart_EMBALAJES);
                    obj_Thread_EMBALAJES.Start();

                    //MAE_Embalajes(SegundaUnidad) ##########################################################################################
                    if (g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.AlbaranesFacturasLineas_segundaUnidad_idEmbalaje!=null)
                    {
                        ThreadStart obj_ThreadStart_EMBALAJESSEGUNDAUNIDAD= new ThreadStart(Obtener_EmbalajesSegundaUnidad_Modelo_ParaListado);
                        Thread obj_Thread_EMBALAJESSEGUNDAUNIDAD = new Thread(obj_ThreadStart_EMBALAJESSEGUNDAUNIDAD);
                        obj_Thread_EMBALAJESSEGUNDAUNIDAD.Start();
                    }
                    else
                    {
                        g_bol_Hilos_Terminados_Modelo_PARALISTADO[1] = true;
                    }

                    //MAE_Articulos_Trazabilidad ##########################################################################################
                    ThreadStart obj_ThreadStart_ARTICULOSTRAZABILIDAD = new ThreadStart(Obtener_ArticulosTrazabilidad_Modelo_ParaListado);
                    Thread obj_Thread_ARTICULOSTRAZABILIDAD = new Thread(obj_ThreadStart_ARTICULOSTRAZABILIDAD);
                    obj_Thread_ARTICULOSTRAZABILIDAD.Start();


                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_PARALISTADO)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_ParaListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_Embalajes_Modelo_ParaListado()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEMBALAJES_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);
                //Obtener valores
                object[] arr_Parametros = { g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.AlbaranesFacturasLineas_idEmbalaje };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.Embalaje_Modelo = (MAE_Embalajes)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_PARALISTADO[0] = true;
            }
        }
        private void Obtener_EmbalajesSegundaUnidad_Modelo_ParaListado()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEMBALAJES_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);
                //Obtener valores
                object[] arr_Parametros = { g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.AlbaranesFacturasLineas_segundaUnidad_idEmbalaje.Value };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.EmbalajeRelacional_Modelo = (MAE_Embalajes)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
               
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_PARALISTADO[1] = true;
            }
        }
        private void Obtener_ArticulosTrazabilidad_Modelo_ParaListado()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEARTICULOSTRAZABILIDAD_OBTENERMODELO_POR_ID, BindingFlags.Instance | BindingFlags.NonPublic);
                //Obtener valores
                object[] arr_Parametros = { g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.idArticulo_Trazabilidad };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.Articulos_Trazabilidad_Modelo = (MAE_Articulos_Trazabilidad)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);               
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_PARALISTADO[2] = true;
            }
        }
        #endregion
        #endregion
        #endregion

        #region Listado
        private List<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo> g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = null;

        public List<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo> Obtener_Registros_Para_Listado_Por_IdAlbaranFacturaLinea(long _lng_idAlbaranFacturaLinea)
        {
            g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = null;

            try
            {
                //Instanciar el listado
                g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = new List<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo>();

                   
                //parametros
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();
                        
                string str_SQL = Obtener_Consulta_Para_Listado() +
                                    " WHERE " +
                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) + " is null and " +
                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + "=@idAlbaranFacturaLinea "; 

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idAlbaranFacturaLinea", _lng_idAlbaranFacturaLinea));
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Ejecutar
                Ejecutar_Consulta_Modelo_Listado_ParaListado(str_SQL,
                                                            arr_Parametros);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Obtener_Registros_Para_Listado_Por_IdAlbaranFacturaLinea), true);
            }

            return g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo;
        }

        public List<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo> Obtener_Registros_Para_Listado_Por_FacturaCabecera(long _lng_idFacturaCabecera)
        {
            g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = null;

            try
            {
                //Instanciar el listado
                g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = new List<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo>();

                //parametros
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_SQL = Obtener_Consulta_Para_Listado() +
                                    " INNER JOIN " + nameof(VTA_FacturasCabecera) + " on " + nameof(VTA_AlbaranesFacturasLineas) + "." + nameof(VTA_AlbaranesFacturasLineas.idFacturaCabecera) + "=" + nameof(VTA_FacturasCabecera) + "." + nameof(VTA_FacturasCabecera.id) +
                                    " WHERE " +
                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) + " is null and " +
                                        nameof(VTA_FacturasCabecera) + "." + nameof(VTA_FacturasCabecera.id) + "=@id and " +
                                        "( not " +nameof(VTA_AlbaranesFacturasLineas) + "." + nameof(VTA_AlbaranesFacturasLineas.idFacturaCabecera) + " is null) ";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@id", _lng_idFacturaCabecera));
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Ejecutar
                Ejecutar_Consulta_Modelo_Listado_ParaListado(str_SQL,
                                                            arr_Parametros);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Obtener_Registros_Para_Listado_Por_FacturaCabecera), true);
            }

            return g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo;
        }

        public List<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo> Obtener_Registros_Para_Listado_Por_AlbaranCabecera(long _lng_idAlbaranCabecera)
        {
            g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = null;

            try
            {
                //Instanciar el listado
                g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = new List<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo>();

                //parametros
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_SQL = Obtener_Consulta_Para_Listado() +
                                    " INNER JOIN " + nameof(VTA_AlbaranesCabecera) + " on " + nameof(VTA_AlbaranesFacturasLineas) + "." + nameof(VTA_AlbaranesFacturasLineas.idAlbaranCabecera) + "=" + nameof(VTA_AlbaranesCabecera) + "." + nameof(VTA_AlbaranesCabecera.id) +
                                    " WHERE " +
                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) + " is null and " +
                                        nameof(VTA_AlbaranesCabecera) + "." + nameof(VTA_AlbaranesCabecera.id) + "=@id and " +
                                        "( not " + nameof(VTA_AlbaranesFacturasLineas) + "." + nameof(VTA_AlbaranesFacturasLineas.idAlbaranCabecera) + " is null) ";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@id", _lng_idAlbaranCabecera));
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Ejecutar
                Ejecutar_Consulta_Modelo_Listado_ParaListado(str_SQL,
                                                            arr_Parametros);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Obtener_Registros_Para_Listado_Por_AlbaranCabecera), true);
            }

            return g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo;
        }

        #region Ejecutar Consulta Modelo Listado Para Listado
        //Listado de modelos Relacionados
        private List<MAE_Embalajes> g_lst_MAE_Embalajes_PARALISTADO = null;
        private List<MAE_Embalajes> g_lst_MAE_Embalajes_SEGUNDAUNIDAD_PARALISTADO = null;
        private List<MAE_Articulos_Trazabilidad> g_lst_MAE_Articulos_Trazabilidad_PARALISTADO = null;

        //Hilos
        private static int g_int_TotalHilos_Modelo_Listado_PARALISTADO = 3;
        private bool[] g_bol_Hilos_Terminados_Modelo_Listado_PARALISTADO = new bool[g_int_TotalHilos_Modelo_Listado_PARALISTADO];

        private void Ejecutar_Consulta_Modelo_Listado_ParaListado(string _str_SQL,
                                                                    object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo>(_str_SQL, _arr_Parametros).ToList();

                #region Rellenar tablas Relacionadas
                if (g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo != null && g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.Count > 0)
                {
                    #region PRIMERO BUSCO LOS DATOS DE LAS TABLAS RELACIONADAS
                    //reiniciar Valores de los hilos
                    for (int int_Contador = 0; int_Contador < g_int_TotalHilos_Modelo_Listado_PARALISTADO; int_Contador++)
                    {
                        g_bol_Hilos_Terminados_Modelo_Listado_PARALISTADO[int_Contador] = false;
                    }

                    //MAE_Embalajes
                    ThreadStart obj_ThreadStart_EMBALAJES = new ThreadStart(Obtener_Embalajes_Modelo_Listado_PARALISTADO);
                    Thread obj_Thread_EMBALAJES = new Thread(obj_ThreadStart_EMBALAJES);
                    obj_Thread_EMBALAJES.Start();

                    //MAE_Embalajes(Segunda Unidad)
                    ThreadStart obj_ThreadStart_EMBALAJESSEGUNDAUNIDAD = new ThreadStart(Obtener_EmbalajesSegundaUnidad_Modelo_Listado_PARALISTADO);
                    Thread obj_Thread_EMBALAJESSEGUNDAUNIDAD = new Thread(obj_ThreadStart_EMBALAJESSEGUNDAUNIDAD);
                    obj_Thread_EMBALAJESSEGUNDAUNIDAD.Start();

                    //MAE_Articulos_Trazabilidad
                    ThreadStart obj_ThreadStart_ARTICULOSTRAZABILIDAD = new ThreadStart(Obtener_ArticuloTrazabilidad_Modelo_Listado_PARALISTADO);
                    Thread obj_Thread_ARTICULOSTRAZABILIDAD = new Thread(obj_ThreadStart_ARTICULOSTRAZABILIDAD);
                    obj_Thread_ARTICULOSTRAZABILIDAD.Start();

                    //Esperando a que terminen todos los hilos .........................................
                    bool bol_Termino = false;
                    while (bol_Termino == false)
                    {
                        bol_Termino = true;
                        foreach (bool bol_Termino_Hilo in g_bol_Hilos_Terminados_Modelo_Listado_PARALISTADO)
                        {
                            if (bol_Termino_Hilo == false)
                            {
                                bol_Termino = false;
                                break;
                            }
                        }

                        Thread.Sleep(10);
                    }
                    //.................................................................................
                    #endregion

                    #region DESPUES SE LO VOY ASIGNANDO A LOS REGISTRO UNO A UNO
                    foreach (INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo in g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo)
                    {
                        //MAE_Embalajes #############################################
                        if (g_lst_MAE_Embalajes_PARALISTADO != null &&
                            g_lst_MAE_Embalajes_PARALISTADO.Count > 0)
                        {
                            mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.Embalaje_Modelo = g_lst_MAE_Embalajes_PARALISTADO.Where(m => m.id == mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.AlbaranesFacturasLineas_idEmbalaje).FirstOrDefault();
                        }

                        //MAE_Embalajes(SegundaUnidad) #############################################
                        if (mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.AlbaranesFacturasLineas_segundaUnidad_idEmbalaje != null &&
                            g_lst_MAE_Embalajes_SEGUNDAUNIDAD_PARALISTADO != null &&
                            g_lst_MAE_Embalajes_SEGUNDAUNIDAD_PARALISTADO.Count > 0)
                        {
                            mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.EmbalajeRelacional_Modelo = g_lst_MAE_Embalajes_SEGUNDAUNIDAD_PARALISTADO.Where(m => m.id == mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.AlbaranesFacturasLineas_segundaUnidad_idEmbalaje.Value).FirstOrDefault();
                        }

                        //MAE_Articulos_Trazabilidad
                        if (g_lst_MAE_Articulos_Trazabilidad_PARALISTADO != null &&
                            g_lst_MAE_Articulos_Trazabilidad_PARALISTADO.Count > 0)
                        {
                            mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.Articulos_Trazabilidad_Modelo = g_lst_MAE_Articulos_Trazabilidad_PARALISTADO.Where(m => m.id == mdl_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.idArticulo_Trazabilidad).FirstOrDefault();
                        }

                    }
                    #endregion
                }
                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado_ParaListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #region Tablas Relacionadas
        private void Obtener_Embalajes_Modelo_Listado_PARALISTADO()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEMBALAJES_OBTENERMODELOLISTADO_POR_IDS, BindingFlags.Instance | BindingFlags.NonPublic);
                //Obtener valores
                object[] arr_Parametros = { g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.Select(m=>m.AlbaranesFacturasLineas_idEmbalaje).ToList() };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_lst_MAE_Embalajes_PARALISTADO = (List<MAE_Embalajes>)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado_PARALISTADO[0] = true;
            }
        }
        private void Obtener_EmbalajesSegundaUnidad_Modelo_Listado_PARALISTADO()
        {
            try
            {
                List<long> lst_AUX = g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.Where(m=>m.AlbaranesFacturasLineas_segundaUnidad_idEmbalaje!=null).Select(m => m.AlbaranesFacturasLineas_segundaUnidad_idEmbalaje.Value).ToList();

                if (lst_AUX != null && lst_AUX.Count > 0)
                {
                    //Cargamos el ensamblado
                    Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                    //Obtenemos el tipo de la clase
                    Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                    //creamos la instancia
                    var obj_Clase = Activator.CreateInstance(m_type);
                    //Cargamos el metodo solicitado
                    MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEMBALAJES_OBTENERMODELOLISTADO_POR_IDS, BindingFlags.Instance | BindingFlags.NonPublic);
                    //Obtener valores
                    object[] arr_Parametros = { lst_AUX };
                    //Pasamos los parametros al metodo y lo ejecutamos
                    g_lst_MAE_Embalajes_SEGUNDAUNIDAD_PARALISTADO = (List<MAE_Embalajes>)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
                }
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado_PARALISTADO[1] = true;
            }
        }
        private void Obtener_ArticuloTrazabilidad_Modelo_Listado_PARALISTADO()
        {
            try
            {
                //Cargamos el ensamblado
                Assembly m_assembly = Assembly.LoadFrom(Variables.G_STR_LIBRERIA_RUTAINICIAL + @"\" + Variables.G_STR_LIBRERIA_MAESTROS + ".dll");
                //Obtenemos el tipo de la clase
                Type m_type = m_assembly.GetType(Variables.G_STR_LIBRERIA_MAESTROS + "." + Variables.G_STR_LIBRERIA_DATOSMAESTROS);
                //creamos la instancia
                var obj_Clase = Activator.CreateInstance(m_type);
                //Cargamos el metodo solicitado
                MethodInfo obj_MethodInfo = obj_Clase.GetType().GetMethod(Variables.G_STR_LIBRERIA_DATOSMAESTROS_PROCEDIMIENTO_MAEARTICULOSTRAZABILIDAD_OBTENERMODELOLISTADO_POR_IDS, BindingFlags.Instance | BindingFlags.NonPublic);
                //Obtener valores
                object[] arr_Parametros = { g_lst_INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.Select(m => m.idArticulo_Trazabilidad).ToList() };
                //Pasamos los parametros al metodo y lo ejecutamos
                g_lst_MAE_Articulos_Trazabilidad_PARALISTADO = (List<MAE_Articulos_Trazabilidad>)obj_MethodInfo.Invoke(obj_Clase, arr_Parametros);
            }
            catch (Control_Errores)
            { }
            finally
            {
                g_bol_Hilos_Terminados_Modelo_Listado_PARALISTADO[2] = true;
            }
        }
        #endregion
        #endregion
        #endregion

        private string Obtener_Consulta_Para_Listado()
        {
            return
                  " SELECT " +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.id) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.idArticulo_Trazabilidad) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idArticulo_Trazabilidad) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.idAlbaranFacturaLinea) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.cantidad) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.cantidad) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.segundaUnidad_cantidad) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.segundaUnidad_cantidad) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.fechaBorrado) + " = " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.AlbaranesFacturasLineas_idEmbalaje) + " = " + nameof(VTA_AlbaranesFacturasLineas) + "." + nameof(VTA_AlbaranesFacturasLineas.idEmbalaje) + "," +
                            nameof(INTERNO_VTA_AlbaranesFacturasLineas_Trazabilidad_Listado_Modelo.AlbaranesFacturasLineas_segundaUnidad_idEmbalaje) + " = " + nameof(VTA_AlbaranesFacturasLineas) + "." + nameof(VTA_AlbaranesFacturasLineas.segundaUnidad_idEmbalaje) + 
                        " FROM " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                        " INNER JOIN " + nameof(VTA_AlbaranesFacturasLineas) + " ON " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + " = " + nameof(VTA_AlbaranesFacturasLineas) + "." + nameof(VTA_AlbaranesFacturasLineas.id);
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private VTA_AlbaranesFacturasLineas_Trazabilidad g_mdl_VTA_AlbaranesFacturasLineas_Trazabilidad = null;
        public VTA_AlbaranesFacturasLineas_Trazabilidad Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_VTA_AlbaranesFacturasLineas_Trazabilidad;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_VTA_AlbaranesFacturasLineas_Trazabilidad = obj_Exferia_Entities.Database.SqlQuery<VTA_AlbaranesFacturasLineas_Trazabilidad>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        #region Modelo Listado
        private List<VTA_AlbaranesFacturasLineas_Trazabilidad> g_lst_VTA_AlbaranesFacturasLineas_Trazabilidad = null;
        public List<VTA_AlbaranesFacturasLineas_Trazabilidad> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {

                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtro_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(VTA_AlbaranesFacturasLineas_Trazabilidad),
                                                                                                 nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id),
                                                                                                 G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                                 _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                    " WHERE " +
                                        str_Filtro_IDS; 

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_VTA_AlbaranesFacturasLineas_Trazabilidad;
        }

        #region Ejecutar Consulta

        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el modelo
                g_lst_VTA_AlbaranesFacturasLineas_Trazabilidad = obj_Exferia_Entities.Database.SqlQuery<VTA_AlbaranesFacturasLineas_Trazabilidad>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) + " , " +
                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idArticulo_Trazabilidad) + " , " +
                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + " , " +
                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.cantidad) + " , " +
                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.segundaUnidad_cantidad) + " , " +
                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) + "." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) +
                " FROM " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                VTA_AlbaranesFacturasLineas_Trazabilidad mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_AGrabar = (VTA_AlbaranesFacturasLineas_Trazabilidad)_mdl_obj;
                VTA_AlbaranesFacturasLineas_Trazabilidad mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_DatosViejos = new VTA_AlbaranesFacturasLineas_Trazabilidad();

                // Ver si existe ######################################################################
                VTA_AlbaranesFacturasLineas_Trazabilidad mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final = Obtener_Modelo_Por_Id(mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_AGrabar.id);
                //###################################################################################### 

                if (mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final, mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_DatosViejos, false, false);

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_AGrabar, mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                                            " SET " +
                                                nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idArticulo_Trazabilidad) + "=@idArticulo_Trazabilidad," +
                                                nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + "=@idAlbaranFacturaLinea," +
                                                nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.cantidad) + "=@cantidad," +
                                                nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.segundaUnidad_cantidad) + "=@segundaUnidad_cantidad," +
                                                nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@idArticulo_Trazabilidad",  mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.idArticulo_Trazabilidad),
                        new SqlParameter("@idAlbaranFacturaLinea",  mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.idAlbaranFacturaLinea),
                        new SqlParameter("@cantidad",  mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.cantidad),
                        mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.segundaUnidad_cantidad!=null
                            ?   new SqlParameter("@segundaUnidad_cantidad", mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.segundaUnidad_cantidad.Value)
                            :   new SqlParameter("@segundaUnidad_cantidad",  DBNull.Value),
                        mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.id;
                }
                else
                {
                    mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final = new VTA_AlbaranesFacturasLineas_Trazabilidad();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_AGrabar, mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                                                " (" +
                                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idArticulo_Trazabilidad) + "," +
                                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + "," +
                                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.cantidad) + "," +
                                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.segundaUnidad_cantidad) + "," +
                                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@idArticulo_Trazabilidad," +
                                                    "@idAlbaranFacturaLinea," +
                                                    "@cantidad," +
                                                    "@segundaUnidad_cantidad," +
                                                    "@fechaBorrado" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idArticulo_Trazabilidad",  mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.idArticulo_Trazabilidad),
                        new SqlParameter("@idAlbaranFacturaLinea",  mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.idAlbaranFacturaLinea),
                        new SqlParameter("@cantidad",  mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.cantidad),
                        mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.segundaUnidad_cantidad!=null
                            ?   new SqlParameter("@segundaUnidad_cantidad", mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.segundaUnidad_cantidad.Value)
                            :   new SqlParameter("@segundaUnidad_cantidad",  DBNull.Value),
                        mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(VTA_AlbaranesFacturasLineas_Trazabilidad), mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_DatosViejos, mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Insertar(VTA_FacturasCabecera _mdl_VTA_FacturasCabecera,VTA_AlbaranesCabecera _mdl_VTA_AlbaranesCabecera, VTA_AlbaranesFacturasLineas _mdl_VTA_AlbaranesFacturasLineas,VTA_AlbaranesFacturasLineas_Trazabilidad _mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_AGrabar)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                VTA_AlbaranesFacturasLineas_Trazabilidad mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_DatosViejos = new VTA_AlbaranesFacturasLineas_Trazabilidad();
                VTA_AlbaranesFacturasLineas_Trazabilidad mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final = new VTA_AlbaranesFacturasLineas_Trazabilidad();

                //Tipo de Accion que se va a realizar
                mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = G_ENUM_TIPOACCION.INT_INSERTAR;

                //Cargar los Datos del Modelo
                Funciones.CopiarPropiedadesObjetos(_mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_AGrabar, mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final, false, false);

                #region INSERT
                string str_SQL_Insert = " INSERT INTO " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                                            " (" +
                                                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idArticulo_Trazabilidad) + "," +
                                                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + "," +
                                                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.cantidad) + "," +
                                                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.segundaUnidad_cantidad) + "," +
                                                    nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) +
                                            " ) " +
                                            " OUTPUT INSERTED." + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) +
                                            " VALUES " +
                                            " ( " +
                                                "@idArticulo_Trazabilidad," +
                                                "@idAlbaranFacturaLinea," +
                                                "@cantidad," +
                                                "@segundaUnidad_cantidad," +
                                                "@fechaBorrado" +
                                            " ) ";
                //Parametros
                object[] arr_Parametros_Insert = new object[]
                {
                    new SqlParameter("@idArticulo_Trazabilidad",  mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.idArticulo_Trazabilidad),
                    new SqlParameter("@idAlbaranFacturaLinea",  mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.idAlbaranFacturaLinea),
                    new SqlParameter("@cantidad",  mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.cantidad),
                    mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.segundaUnidad_cantidad!=null
                        ?   new SqlParameter("@segundaUnidad_cantidad", mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.segundaUnidad_cantidad.Value)
                        :   new SqlParameter("@segundaUnidad_cantidad",  DBNull.Value),
                    mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.fechaBorrado!=null
                        ?   new SqlParameter("@fechaBorrado", mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final.fechaBorrado.Value)
                        :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                };
                #endregion

                //Id de la tabla
                mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                
                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(VTA_AlbaranesFacturasLineas_Trazabilidad), mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_DatosViejos, mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);

                #region TABLAS RELACIONADAS
                #region ARTICULOSMOVIMIENTOSDIARIOS
                if (
                        (
                            _mdl_VTA_FacturasCabecera != null &&
                            _mdl_VTA_AlbaranesFacturasLineas.idAlbaranCabecera == null && _mdl_VTA_AlbaranesFacturasLineas.idArticulo != null
                        )
                        || 
                        (
                            _mdl_VTA_AlbaranesCabecera != null && _mdl_VTA_AlbaranesFacturasLineas.idArticulo != null
                        )
                    )
                {
                    #region Rellenar modelo
                    //Buscar el TipoCompraVenta
                    GEN_TiposCompraVenta mdl_GEN_TiposCompraVenta = Datos_Generales.GEN_TiposCompraVenta_Obtener_Modelo_Por_Id(_mdl_VTA_AlbaranesFacturasLineas.idTipoCompraVenta);

                    INTERNO_ArticuloTrazabilidadDiarioActualizar_Documentos_Modelo mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo = new INTERNO_ArticuloTrazabilidadDiarioActualizar_Documentos_Modelo();

                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.TipoDocumento = _mdl_VTA_FacturasCabecera!=null ? Variables.G_MDL_TIPODOCUMENTOS_MOVIMIENTOSARTICULOS_FACTURAVENTA.Codigo : Variables.G_MDL_TIPODOCUMENTOS_MOVIMIENTOSARTICULOS_ALBARANVENTA.Codigo;

                    //Datos Actuales
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.IdArticulotrazabilidad_Actual = _mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_AGrabar.idArticulo_Trazabilidad;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.IdArticulo_Actual = _mdl_VTA_AlbaranesFacturasLineas.idArticulo.Value;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Fecha_Actual = _mdl_VTA_FacturasCabecera!=null ? _mdl_VTA_FacturasCabecera.fecha : _mdl_VTA_AlbaranesCabecera.fecha;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.IdDelegacion_Actual = _mdl_VTA_FacturasCabecera != null ? _mdl_VTA_FacturasCabecera.idDelegacion : _mdl_VTA_AlbaranesCabecera.idDelegacion;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.IdAlmacen_Actual = _mdl_VTA_AlbaranesFacturasLineas.idAlmacen;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.IdUbicacion_Actual = _mdl_VTA_AlbaranesFacturasLineas.idUbicacion;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Cantidad_Actual = _mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_AGrabar.cantidad;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Cantidad_SegundaUnidad_Actual = _mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_AGrabar.segundaUnidad_cantidad != null ? _mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_AGrabar.segundaUnidad_cantidad.Value : 0m;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.TipoCompraVentaOpcion_Actual = mdl_GEN_TiposCompraVenta != null ? mdl_GEN_TiposCompraVenta.opcion : Variables.G_MDL_TIPOCOMPRAVENTA_OPCION_9.Codigo;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Relacion_Actual = _mdl_VTA_AlbaranesFacturasLineas.relacion;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Operacion_Actual = _mdl_VTA_AlbaranesFacturasLineas.operacion;

                    //Datos Anteriores
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Modificacion = false;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.IdArticulotrazabilidad_Anterior = null;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.IdArticulo_Anterior = null;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Fecha_Anterior = null;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.IdDelegacion_Anterior = null;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.IdAlmacen_Anterior = null;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.IdUbicacion_Anterior = null;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.TipoCompraVentaOpcion_Anterior = "";
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Cantidad_Anterior = null;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Cantidad_SegundaUnidad_Anterior = null;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Relacion_Anterior = null;
                    mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo.Operacion_Anterior = "";
                    #endregion

                    mdl_INTERNO_ValorDevuelto_Modelo = Funciones_ArticuloTrazabilidadMovimientosDiario.Actualizar_ArticuloTrazabilidadMovimientoDiario(mdl_INTERNO_ArticuloDiarioActualizar_Documentos_Modelo);
                }
                #endregion

                #endregion
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Insertar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public INTERNO_ValorDevuelto_Modelo Quitar_CantidadRelacionada(long _lng_idAlbaranFacturaLinea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL_Insertar = " UPDATE " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                                                " SET " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.segundaUnidad_cantidad) + "=null " +
                                            " WHERE " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + " = " + _lng_idAlbaranFacturaLinea;

                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Insertar);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Quitar_CantidadRelacionada), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            bool bol_ActualizarFechaBorrado = false;//Este campo se utiliza por si no se puede borrar, que actualice la fecha de borrado

            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {
                    obj_Exferia_Entities = new Exferia_Entities();
                    obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                    // Ver si existe ######################################################################
                    VTA_AlbaranesFacturasLineas_Trazabilidad mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final = Obtener_Modelo_Por_Id(_lng_id);
                    //######################################################################################

                    if (mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final != null)
                    {
                        //Se intenta borrar, si diera un error porque esta relacionado se graba la fecha de baja
                        try
                        {
                            #region Delete
                            string str_SQL_Delete = " DELETE FROM  " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                                                    " WHERE " +
                                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) + "=@id";
                            //Parametros
                            object[] arr_Parametros_Delete = new object[]
                            {
                                new SqlParameter("@id", _lng_id)
                            };
                            #endregion

                            //Delete
                            obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                            //Grabar un registro de trazabailidad con los datos de la transaccion realizada.
                            Datos_Generales.USR_Trazabilidad_Grabar(typeof(VTA_AlbaranesFacturasLineas_Trazabilidad), null, mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                        }
                        catch (Exception ex)
                        {
                            var sqlException = ex.GetBaseException() as SqlException;
                            if (sqlException != null)
                            {
                                if (sqlException.Errors.Count > 0)
                                {
                                    switch (sqlException.Errors[0].Number)
                                    {
                                        case Control_Errores.G_INT_ERRORCONTROLADO_BORRAR_CONFLICTO_CLAVEFORANEA: // Foreign Key violation
                                            bol_ActualizarFechaBorrado = true;
                                            break;
                                        default:
                                            throw;
                                    }
                                }
                            }
                            else
                            {
                                throw;
                            }
                        }

                        //Actualizar la fecha de baja, al no poder borrarlo por tener relaciones
                        if (bol_ActualizarFechaBorrado)
                        {
                            #region Update
                            string str_SQL_Update = " UPDATE " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                                                        " SET " +
                                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.fechaBorrado) + "=@fechaBorrado " +
                                                    " WHERE " +
                                                        nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id) + "=@id";
                            //Parametros
                            object[] arr_Parametros_Update = new object[]
                            {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                            };
                            #endregion

                            //Update
                            obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                            //Grabar un registro de trazabilidad con los datos de la trasaccion realizada
                            Datos_Generales.USR_Trazabilidad_Grabar(typeof(VTA_AlbaranesFacturasLineas_Trazabilidad), null, mdl_VTA_AlbaranesFacturasLineas_Trazabilidad_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                        }
                    }

                    //Devolver tambien el Objeto
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;

                    // se termina la Trasaccion Correctamente
                    transaccion_SQL.Complete();
                }
                catch (Control_Errores)
                {
                    throw;
                }
                catch (Exception ex)
                {
                    throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Borrar), true);
                }
                finally
                {
                    obj_Exferia_Entities.Database.Connection.Close();
                    obj_Exferia_Entities.Dispose();

                    
                    transaccion_SQL.Dispose();
                }
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            Exferia_Entities obj_INTERNO_ValorDevuelto_Modelo = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_INTERNO_ValorDevuelto_Modelo = new Exferia_Entities();
                obj_INTERNO_ValorDevuelto_Modelo.Configuration.LazyLoadingEnabled = false;

                string str_SQL = " DELETE FROM " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                                    " WHERE " +
                                            nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + "=" + _lng_id + " AND " +
                                            nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idArticulo_Trazabilidad) + " NOT IN (SELECT " + nameof(MAE_Articulos_Trazabilidad.id) + " FROM " + nameof(MAE_Articulos_Trazabilidad) + " WHERE " + nameof(MAE_Articulos_Trazabilidad.idArticulo) + " = " + _lng_idAuxiliar + ")";

                obj_INTERNO_ValorDevuelto_Modelo.Database.ExecuteSqlCommand(str_SQL);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_INTERNO_ValorDevuelto_Modelo.Database.Connection.Close();
                obj_INTERNO_ValorDevuelto_Modelo.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idLineaTrazabilidad = (List<long>)_mdl_obj;

                if (lst_idLineaTrazabilidad != null & lst_idLineaTrazabilidad.Count > 0)
                {
                    string str_Filtro_AlbaranesFacturasLineasTrazabilidad = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(VTA_AlbaranesFacturasLineas_Trazabilidad),
                                                                                                 nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.id),
                                                                                                 G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                                 lst_idLineaTrazabilidad);

                    string str_SQL = " DELETE FROM " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                                        " WHERE " +
                                            str_Filtro_AlbaranesFacturasLineasTrazabilidad; 

                    //Ejecutar
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL, new object[] { });
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }

        public INTERNO_ValorDevuelto_Modelo Borrar_PorAlbaranFacturaLinea(long _lng_idAlbaranFacturaLinea)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL = " DELETE FROM " + nameof(VTA_AlbaranesFacturasLineas_Trazabilidad) +
                                    " WHERE " +
                                            nameof(VTA_AlbaranesFacturasLineas_Trazabilidad.idAlbaranFacturaLinea) + "=" + _lng_idAlbaranFacturaLinea;

                obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(VTA_AlbaranesFacturasLineas_Trazabilidad_Datos) + "/" + nameof(Borrar_PorAlbaranFacturaLinea), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion
    }
}
